define(['plugins/domReady',
 'widgets/Spinner',
 'jquery.highlight',
 'jquery.mobile'
], function(domReady, Spinner, highlight) {
    var spinner = null;
    var _this = null;
    return function(args) {
        var contentController = {
            inSearch: false,
            searchString: null,
            init: function() {
                jQuery.extend(this, args);
                _this = this;
                Spinner.initInstance({
                    parentNode: jQuery("body"),
                    overlayParentNode: jQuery(".main-container")
                });
                ViewerController.events.navigate.subscribe(function(type, args) {
                    domReady(function() {
                        //required accessibility elements         
                        jQuery(".ui-loader").attr({
                            role: "region",
                            "aria-labelledby": "loading"    
                        });
                        jQuery(".ui-loader h1").attr({
                            id: "loading"
                        });
                        jQuery('html').attr({
                            lang: "en-US"
                        });
                        jQuery("main").attr({    
                            role: "main"
                        });
                        jQuery("header").attr({
                            role: "banner"
                        });
                        jQuery('iframe').attr({
                            title: "Main content"
                        });
                        // Saving OSDeliveryEngine. See comment below for more
                        // details.
                        var OSDeliveryEngineBackup = jQuery.extend({}, OSDeliveryEngine);
                        var iframe = jQuery(".loading iframe");                        
                        iframe.on('load', jQuery.proxy(function() {
                            /*
                             * workaround for problem where the OSDeliveryEngine and
                             * it's current context are lost when new content is
                             * loaded.
                             *
                             * This is caused because we use JQuery's "load"
                             * function which loads the content directly into the
                             * current context. The OSDeliveryEngine's settings are
                             * overridden by the incoming Velocity template which
                             * resets OSDeliveryEngine.
                             *
                             * It should be safe to reset to the original
                             * OSDeliveryEngine's configuration each time as it
                             * encompasses all objects from the root node down.
                             */
                            OSDeliveryEngine = OSDeliveryEngineBackup;
                            jQuery(".loaded")
                                .remove();
                            jQuery(".loading")
                                .removeClass()
                                .addClass("loaded");
                            jQuery(".transitioning")
                                .removeClass("transitioning");
                            Spinner.hide();
                            if (_this.inSearch) {
                                jQuery(window)
                                    .load(_this.highlightFunction(_this.searchString));
                            }
                            //required accessibility elements 
                            jQuery('iframe').contents().find("head").append("<title>"+args[0].label+"</title>");   

                        }, this));
                        iframe.attr('src', args[1]);
                    });
                    Spinner.show();
                });
            },
            highlightFunction: function(searchString) {
                setTimeout(function() {
                    jQuery("iframe")
                        .contents()
                        .find("body")
                        .highlight(_this.searchString);
                }, 1000);
            },
            setInSearch: function(inSearch, searchString) {
                this.inSearch = inSearch;
                this.searchString = searchString;
                if (!inSearch) {
                    jQuery("iframe")
                        .contents()
                        .find("body")
                        .unhighlight();
                }
            }
        };
        jQuery(contentController.init());
        return contentController;
    };
});

