define(["plugins/text!widgets/templates/SlideAwayPanel.html"
], function(template) {
    var scrollDistance = 0;
    var prevScrollPos = 0;
    var lastScrollDir = false;
    var MinScrollToHide = 40;
    var MinScrollToShow = 10;
    return function(args) {
        var _this = null;
        var slideAwayPanel = {
            domNode: null,
            panelNode: null,
            init: function() {
                jQuery.extend(this, args);
                _this = this;
                var slideawayTemplate = jQuery(template)
                    .clone();
                this.domNode = slideawayTemplate.get(); // the root node of the
                // scroll-away panel
                this.panelNode = jQuery(slideawayTemplate)
                    .find(".sliding-panel");
                jQuery(this.domNode)
                    .on("scroll", function() {
                        var dir = (this.scrollTop - prevScrollPos) < 0 ? true : false; // get the scroll direction
                        if (lastScrollDir !== dir) {
                            scrollDistance = this.scrollTop - prevScrollPos;
                        } else {
                            scrollDistance += this.scrollTop - prevScrollPos;
                        }
                        if (scrollDistance > MinScrollToHide) {
                            _this.panelNode.removeClass("show-sliding-panel");
                            _this.panelNode.addClass("hide-sliding-panel");
                        } else if (scrollDistance <= MinScrollToShow) {
                            _this.panelNode.removeClass("hide-sliding-panel");
                            _this.panelNode.addClass("show-sliding-panel");
                        }
                        lastScrollDir = dir;
                        prevScrollPos = this.scrollTop;
                    });
            }
        };
        jQuery(slideAwayPanel.init());
        return slideAwayPanel;
    };
});

